JUCE: VST3PluginFormat Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
VST3PluginFormat Class Reference
juce_audio_processors » format_types

Implements a plugin format for VST3s. More...

`#include <juce_VST3PluginFormat.h>`

Inheritance diagram for VST3PluginFormat:

## Public Member Functions
| VST3PluginFormat ()
| Constructor.
| ~VST3PluginFormat () override
| Destructor.
String | getName () const override
| Returns the format name.
bool | canScanForPlugins () const override
| Returns true if this format needs to run a scan to find its list of plugins.
bool | isTrivialToScan () const override
| Should return true if this format is both safe and quick to scan - i.e.
void | findAllTypesForFile (OwnedArray< PluginDescription > &, const String &fileOrIdentifier) override
| This tries to create descriptions for all the plugin types available in a binary module file.
bool | fileMightContainThisPluginType (const String &fileOrIdentifier) override
| Should do a quick check to see if this file or directory might be a plugin of this format.
String | getNameOfPluginFromIdentifier (const String &fileOrIdentifier) override
| Returns a readable version of the name of the plugin that this identifier refers to.
bool | pluginNeedsRescanning (const PluginDescription &) override
| Returns true if this plugin's version or date has changed and it should be re-checked.
StringArray | searchPathsForPlugins (const FileSearchPath &, bool recursive, bool) override
| Searches a suggested set of directories for any plugins in this format.
bool | doesPluginStillExist (const PluginDescription &) override
| Checks whether this plugin could possibly be loaded.
FileSearchPath | getDefaultLocationsToSearch () override
| Returns the typical places to look for this kind of plugin.
void | createARAFactoryAsync (const PluginDescription &, ARAFactoryCreationCallback callback) override
| Tries to create an ARAFactoryWrapper for this description.
Public Member Functions inherited from AudioPluginFormat
| ~AudioPluginFormat () override
| Destructor.
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize)
| Tries to recreate a type from a previously generated PluginDescription.
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize, String &errorMessage)
| Same as above but with the possibility of returning an error message.
void | createPluginInstanceAsync (const PluginDescription &description, double initialSampleRate, int initialBufferSize, PluginCreationCallback)
| Tries to recreate a type from a previously generated PluginDescription.

## Static Public Member Functions
static String | getFormatName ()

## Additional Inherited Members
Public Types inherited from AudioPluginFormat
using | PluginCreationCallback = std::function<void (std::unique_ptr<AudioPluginInstance>, const String&)>
| A callback lambda that is passed to createPluginInstanceAsync()
using | ARAFactoryCreationCallback = std::function<void (ARAFactoryResult)>
| A callback lambda that is passed to getARAFactory()
Protected Member Functions inherited from AudioPluginFormat
| AudioPluginFormat ()

## Detailed Description

Implements a plugin format for VST3s.

## Constructor & Destructor Documentation

## ◆ VST3PluginFormat()

VST3PluginFormat::VST3PluginFormat | ( |  | ) |

Constructor.

## ◆ ~VST3PluginFormat()

VST3PluginFormat::~VST3PluginFormat | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getFormatName()

static String VST3PluginFormat::getFormatName | ( |  | ) |
| static

## ◆ getName()

String VST3PluginFormat::getName | ( |  | ) | const
| overridevirtual

Returns the format name.

E.g. "VST", "AudioUnit", etc.

Implements AudioPluginFormat.

## ◆ canScanForPlugins()

bool VST3PluginFormat::canScanForPlugins | ( |  | ) | const
| overridevirtual

Returns true if this format needs to run a scan to find its list of plugins.

Implements AudioPluginFormat.

## ◆ isTrivialToScan()

bool VST3PluginFormat::isTrivialToScan | ( |  | ) | const
| overridevirtual

Should return true if this format is both safe and quick to scan - i.e.

if a file can be scanned within a few milliseconds on a background thread, without actually needing to load an executable.

Implements AudioPluginFormat.

## ◆ findAllTypesForFile()

void VST3PluginFormat::findAllTypesForFile | ( | OwnedArray< PluginDescription > & | results,
|  | const String & | fileOrIdentifier )
| overridevirtual

This tries to create descriptions for all the plugin types available in a binary module file.

The file will be some kind of DLL or bundle.

Normally there will only be one type returned, but some plugins (e.g. VST shells) can use a single DLL to create a set of different plugin subtypes, so in that case, each subtype is returned as a separate object.

Implements AudioPluginFormat.

## ◆ fileMightContainThisPluginType()

bool VST3PluginFormat::fileMightContainThisPluginType | ( | const String & | fileOrIdentifier | ) |
| overridevirtual

Should do a quick check to see if this file or directory might be a plugin of this format.

This is for searching for potential files, so it shouldn't actually try to load the plugin or do anything time-consuming.

Implements AudioPluginFormat.

## ◆ getNameOfPluginFromIdentifier()

String VST3PluginFormat::getNameOfPluginFromIdentifier | ( | const String & | fileOrIdentifier | ) |
| overridevirtual

Returns a readable version of the name of the plugin that this identifier refers to.

Implements AudioPluginFormat.

## ◆ pluginNeedsRescanning()

bool VST3PluginFormat::pluginNeedsRescanning | ( | const PluginDescription & |  | ) |
| overridevirtual

Returns true if this plugin's version or date has changed and it should be re-checked.

Implements AudioPluginFormat.

## ◆ searchPathsForPlugins()

StringArray VST3PluginFormat::searchPathsForPlugins | ( | const FileSearchPath & | directoriesToSearch,
|  | bool | recursive,
|  | bool | allowPluginsWhichRequireAsynchronousInstantiation )
| overridevirtual

Searches a suggested set of directories for any plugins in this format.

The path might be ignored, e.g. by AUs, which are found by the OS rather than manually.

Parameters

  directoriesToSearch | This specifies which directories shall be searched for plug-ins.
  recursive | Should the search recursively traverse folders.
  allowPluginsWhichRequireAsynchronousInstantiation | If this is false then plug-ins which require asynchronous creation will be excluded.

Implements AudioPluginFormat.

## ◆ doesPluginStillExist()

bool VST3PluginFormat::doesPluginStillExist | ( | const PluginDescription & |  | ) |
| overridevirtual

Checks whether this plugin could possibly be loaded.

It doesn't actually need to load it, just to check whether the file or component still exists.

Implements AudioPluginFormat.

## ◆ getDefaultLocationsToSearch()

FileSearchPath VST3PluginFormat::getDefaultLocationsToSearch | ( |  | ) |
| overridevirtual

Returns the typical places to look for this kind of plugin.

Note that if this returns no paths, it means that the format doesn't search in files or folders, e.g. AudioUnits.

Implements AudioPluginFormat.

## ◆ createARAFactoryAsync()

void VST3PluginFormat::createARAFactoryAsync | ( | const PluginDescription & | ,
|  | ARAFactoryCreationCallback | callback )
| overridevirtual

Tries to create an ARAFactoryWrapper for this description.

The result of the operation will be wrapped into an ARAFactoryResult, which will be passed to a callback object supplied by the caller.

See also
  AudioPluginFormatManager::createARAFactoryAsync

Reimplemented from AudioPluginFormat.

The documentation for this class was generated from the following file:

- juce_VST3PluginFormat.h